#!/usr/bin/perl -w
#
# Programm zum einmaligen ndern der Umlaute in Dateinamen von 850 nach iso8859-1
#
# (C) Arndt Reimers, u2794@bwl.uni-kiel.de
#
# Der dahinterstehende Algorithmus ist komplett frei, jeder darf es weitergeben, nutzen, ndern und
# in andere Programme/Projekte realisieren. 
#
# selbsterklrende Variablen setzen
#
$arbeitsverz  = "/home";
$tempverz     = "/tmp";
$ablagedatei  = "ablagedatei";
$anfangstiefe = 2;
#
#
# Programmbeginn
#
# Feststellung der maximalen Verzeichnistiefe
#
print "Verzeichnistiefe feststellen:\n";
$endetiefe = `cd $arbeitsverz; find . | sed 's#[^/]*##g' | sort -u | wc -l`;
print "Verzeichnistiefe ist $endetiefe\n";
#
# Beginn der Schleife ber alle Verzeichnistiefen
#
$i = $anfangstiefe;
while($i <= $endetiefe) {
#
   print "Tiefe: $i\n";
#
# Einlesen aller Verzeichnisse, deren Umlaute gendert werden mssen
# und speichern in die Zwischenablage
#
   $befehl = "find $arbeitsverz \-name \\* \-print \-maxdepth $i | awk '/\\224|\\201|\\216|\\231|\\232|\\204|\\/ {print}' > $tempverz/$ablagedatei.$i";
   `$befehl`;
#
# Umformen
#
   $befehl = "recode --force 850..iso88591 < $tempverz/$ablagedatei.$i > $tempverz/$ablagedatei.$i.0";
   `$befehl`;
#
# Prfen: Dateilnge der beiden Ablagedateien mssen gleich lang sein!
#
   $ablage  = `cat $tempverz/$ablagedatei.$i   | wc -c`;
   $ablage0 = `cat $tempverz/$ablagedatei.$i.0 | wc -c`;
   if($ablage == $ablage0) {
#
# Jeden Eintrag der Ablagedatei lesen und den Dateinamen umformen
#
# ffnen der Ablagedateien
#
      open(DATEI, "$tempverz/$ablagedatei.$i");
      open(DATEI0,"$tempverz/$ablagedatei.$i.0");
#
# Schleife ber jeden Eintrag der Zwischenablage
#
      while(<DATEI>) {
#
# Eintrag alt einlesen
#
         chomp($dateiname = $_);
#
# das gerade drankommende Verzeichnis extrahieren
#
         $_ = $dateiname;
         s#/[^/]*$##;
         $verz = $_;
#
# Eintrag neu einlesen
#
         $dateiname0 = <DATEI0>;
         chomp($dateiname0);
#
# Verzeichnisteil rausnehmen und durch den anderen
# wieder einsetzen
#
         $_ = $dateiname0;
         s#[^/]*/##g;
         $dateiname0 = "$verz/" . $_;
#
# Zur Kontrolle ausgeben
#
         print "Neuer Name: $dateiname0\n";
#
# umbenennen!!
#
         rename($dateiname,$dateiname0);
      }
#
# beenden: schlieen
#
      close(DATEI0);
      close(DATEI);
   }
#
# und die nchste Verzeichnistiefe whlen!
#
$i++;
}

